diff --git a/libr/core/bin.c b/libr/core/bin.c
index a240d660cdc..bd4e0c4e30f 100644
--- a/libr/core/bin.c
+++ b/libr/core/bin.c
@@ -1216,6 +1216,38 @@ static int bin_symbols(RCore *r, int mode, ut64 laddr, int va, ut64 at, const ch
 	return bin_symbols_internal (r, mode, laddr, va, at, name, false);
 }
 
+
+static char *build_hash_string(int mode, const char *chksum, ut8 *data, ut32 datalen) {
+
+	char *chkstr = NULL, *aux, *ret = NULL;
+	char tmp[128];
+	const char *ptr = chksum;
+	int i;
+	do {
+		for (i = 0; *ptr && *ptr != ',' && i < sizeof(tmp) -1; i++)
+			tmp[i] = *ptr++;
+		tmp[i] = '\0';
+		chkstr = r_hash_to_string (NULL, tmp, data, datalen);
+		if (!chkstr) {
+			if (*ptr && *ptr == ',') ptr++;
+			continue;
+		}
+		if (IS_MODE_SIMPLE (mode)) {
+			aux = r_str_newf ("%s ", chkstr);
+		} else if (IS_MODE_JSON (mode)) {
+			aux = r_str_newf ("\"%s\":\"%s\",", tmp, chkstr);
+		} else {
+			aux = r_str_newf ("%s=%s ", tmp, chkstr);
+		}
+		ret = r_str_concat (ret, aux);
+		free (chkstr);
+		free (aux);
+		if (*ptr && *ptr == ',') ptr++;
+	} while (*ptr);
+
+	return ret;
+}
+
 static int bin_sections(RCore *r, int mode, ut64 laddr, int va, ut64 at, const char *name, const char *chksum) {
 	char str[R_FLAG_NAME_SIZE];
 	RBinSection *section;
@@ -1294,34 +1326,34 @@ static int bin_sections(RCore *r, int mode, ut64 laddr, int va, ut64 at, const c
 			r_io_section_add (r->io, section->paddr, addr, section->size,
 				section->vsize, section->srwx, section->name, 0, fd);
 		} else if (IS_MODE_SIMPLE (mode)) {
-			char *chkstr = NULL;
+			char *hashstr = NULL;
 			if (chksum) {
 				ut8 *data = malloc (section->size);
+				if (!data) return false;
 				ut32 datalen = section->size;
 				r_io_pread (r->io, section->paddr, data, datalen);
-				chkstr = r_hash_to_string (NULL, chksum, data, datalen);
+				hashstr = build_hash_string (mode, chksum,
+							data, datalen);
 				free (data);
 			}
 			r_cons_printf ("0x%"PFMT64x" 0x%"PFMT64x" %s %s%s%s\n",
 				addr, addr + section->size,
 				perms,
-				chkstr ? chkstr : "", chkstr ? " " : "",
+				hashstr ? hashstr : "", hashstr ? " " : "",
 				section->name
 			);
-			free (chkstr);
+			free (hashstr);
 		} else if (IS_MODE_JSON (mode)) {
 			char *hashstr = NULL;
-
 			if (chksum) {
-				char *chkstr;
 				ut8 *data = malloc (section->size);
+				if (!data) return false;
 				ut32 datalen = section->size;
 				r_io_pread (r->io, section->paddr, data, datalen);
-				chkstr = r_hash_to_string (NULL, chksum, data, datalen);
+				hashstr = build_hash_string (mode, chksum,
+							data, datalen);
 				free (data);
-				hashstr = malloc (strlen (chkstr)+strlen (chksum)+7);
-				sprintf (hashstr, "\"%s\":\"%s\",", chksum, chkstr);
-				free (chkstr);
+
 			}
 			r_cons_printf ("%s{\"name\":\"%s\","
 				"\"size\":%"PFMT64d","
@@ -1366,16 +1398,14 @@ static int bin_sections(RCore *r, int mode, ut64 laddr, int va, ut64 at, const c
 		} else {
 			char *hashstr = NULL, str[128];
 			if (chksum) {
-				char *chkstr;
 				ut8 *data = malloc (section->size);
+				if (!data) return false;
 				ut32 datalen = section->size;
 				// VA READ IS BROKEN?
 				r_io_pread (r->io, section->paddr, data, datalen);
-				chkstr = r_hash_to_string (NULL, chksum, data, datalen);
+				hashstr = build_hash_string (mode, chksum,
+							data, datalen);
 				free (data);
-				hashstr = malloc (strlen (chkstr)+strlen (chksum)+3);
-				sprintf (hashstr, "%s=%s ", chksum, chkstr);
-				free (chkstr);
 			}
 			if (section->arch || section->bits) {
 				const char *arch = section->arch;
@@ -1392,7 +1422,7 @@ static int bin_sections(RCore *r, int mode, ut64 laddr, int va, ut64 at, const c
 		}
 		i++;
 	}
-	if (IS_MODE_JSON (mode)) r_cons_printf ("]");
+	if (IS_MODE_JSON (mode)) r_cons_printf ("]\n");
 	else if (IS_MODE_NORMAL (mode) && !at) r_cons_printf ("\n%i sections\n", i);
 
 	return true;
diff --git a/libr/core/cmd_info.c b/libr/core/cmd_info.c
index f74ea4f0c7a..df7c15d910b 100644
--- a/libr/core/cmd_info.c
+++ b/libr/core/cmd_info.c
@@ -258,12 +258,12 @@ static int cmd_info(void *data, const char *input) {
 				r_core_bin_load (core, fn, baddr);
 			 }
 			break;
-	#define RBININFO(n,x) \
+	#define RBININFO(n,x,y) \
 	if (is_array) { \
 		if (is_array==1) is_array++; else r_cons_printf (","); \
 		r_cons_printf ("\"%s\":",n); \
 	}\
-	r_core_bin_info (core, x, mode, va, NULL, NULL);
+	r_core_bin_info (core, x, mode, va, NULL, y);
 		case 'A':
 			newline = 0;
 			if (input[1]=='j') {
@@ -274,21 +274,33 @@ static int cmd_info(void *data, const char *input) {
 				r_bin_list_archs (core->bin, 1);
 			}
 			break;
-		case 'E': RBININFO ("exports", R_CORE_BIN_ACC_EXPORTS); break;
-		case 'Z': RBININFO ("size", R_CORE_BIN_ACC_SIZE); break;
-		case 'S': RBININFO ("sections", R_CORE_BIN_ACC_SECTIONS); break;
-		case 'h': RBININFO ("fields", R_CORE_BIN_ACC_FIELDS); break;
-		case 'l': RBININFO ("libs", R_CORE_BIN_ACC_LIBS); break;
+		case 'E': RBININFO ("exports", R_CORE_BIN_ACC_EXPORTS, NULL); break;
+		case 'Z': RBININFO ("size", R_CORE_BIN_ACC_SIZE, NULL); break;
+		case 'S':
+			//we comes from ia or iS
+			if ((input[1] == 'm' && input[2] == 'z') || !input[1]) {
+				RBININFO ("sections", R_CORE_BIN_ACC_SECTIONS, NULL);
+			} else  { //iS entropy,sha1
+				RBININFO ("sections", R_CORE_BIN_ACC_SECTIONS, input + 2);
+				//we move input until get '\0'
+				while (*(++input));
+				//input-- because we are inside a while that does input++
+				// oob read if not input--
+				input--;
+			}
+			break;
+		case 'h': RBININFO ("fields", R_CORE_BIN_ACC_FIELDS, NULL); break;
+		case 'l': RBININFO ("libs", R_CORE_BIN_ACC_LIBS, NULL); break;
 		case 'L': r_bin_list (core->bin); break;
-		case 's': RBININFO ("symbols", R_CORE_BIN_ACC_SYMBOLS); break;
+		case 's': RBININFO ("symbols", R_CORE_BIN_ACC_SYMBOLS, NULL); break;
 		case 'R':
-		case 'r': RBININFO ("relocs", R_CORE_BIN_ACC_RELOCS); break;
-		case 'd': RBININFO ("dwarf", R_CORE_BIN_ACC_DWARF); break;
-		case 'i': RBININFO ("imports",R_CORE_BIN_ACC_IMPORTS); break;
-		case 'I': RBININFO ("info", R_CORE_BIN_ACC_INFO); break;
-		case 'e': RBININFO ("entries", R_CORE_BIN_ACC_ENTRIES); break;
-		case 'M': RBININFO ("main", R_CORE_BIN_ACC_MAIN); break;
-		case 'm': RBININFO ("memory", R_CORE_BIN_ACC_MEM); break;
+		case 'r': RBININFO ("relocs", R_CORE_BIN_ACC_RELOCS, NULL); break;
+		case 'd': RBININFO ("dwarf", R_CORE_BIN_ACC_DWARF, NULL); break;
+		case 'i': RBININFO ("imports",R_CORE_BIN_ACC_IMPORTS, NULL); break;
+		case 'I': RBININFO ("info", R_CORE_BIN_ACC_INFO, NULL); break;
+		case 'e': RBININFO ("entries", R_CORE_BIN_ACC_ENTRIES, NULL); break;
+		case 'M': RBININFO ("main", R_CORE_BIN_ACC_MAIN, NULL); break;
+		case 'm': RBININFO ("memory", R_CORE_BIN_ACC_MEM, NULL); break;
 		case 'z':
 			if (input[1] == 'z') {
 				/* TODO: reimplement in C to avoid forks */
@@ -317,7 +329,7 @@ static int cmd_info(void *data, const char *input) {
 				free (ret);
 				input++;
 			} else {
-				RBININFO ("strings", R_CORE_BIN_ACC_STRINGS);
+				RBININFO ("strings", R_CORE_BIN_ACC_STRINGS, NULL);
 			}
 			break;
 		case 'c': // for r2 `ic`
@@ -382,11 +394,11 @@ static int cmd_info(void *data, const char *input) {
 								r_cons_newline ();
 						}
 					} else {
-						RBININFO ("classes", R_CORE_BIN_ACC_CLASSES);
+						RBININFO ("classes", R_CORE_BIN_ACC_CLASSES, NULL);
 					}
 				}
 			} else {
-				RBININFO ("classes", R_CORE_BIN_ACC_CLASSES);
+				RBININFO ("classes", R_CORE_BIN_ACC_CLASSES, NULL);
 			}
 			break;
 		case 'D':
@@ -430,7 +442,7 @@ static int cmd_info(void *data, const char *input) {
 				"io", " [file]", "Load info from file (or last opened) use bin.baddr",
 				"ir|iR", "", "Relocs",
 				"is", "", "Symbols",
-				"iS", "", "Sections",
+				"iS ", "[entropy,sha1]", "Sections (choose which hash algorithm to use)",
 				"iz", "", "Strings in data sections",
 				"izz", "", "Search for Strings in the whole binary",
 				NULL
diff --git a/libr/hash/hash.c b/libr/hash/hash.c
index f469c79a620..6fd02528a44 100644
--- a/libr/hash/hash.c
+++ b/libr/hash/hash.c
@@ -168,12 +168,12 @@ R_API void r_hash_do_spice(RHash *ctx, int algo, int loops, RHashSeed *seed) {
 
 R_API char *r_hash_to_string(RHash *ctx, const char *name, const ut8 *data, int len) {
 	char *digest_hex = NULL;
-	int i, digest_size;
+	int i, digest_size, r;
 	ut64 algo = r_hash_name_to_bits (name);
-	if (!ctx)
-		ctx = r_hash_new (true, algo);
+	if (!algo) return NULL;
+	if (!ctx) ctx = r_hash_new (true, algo);
 	r_hash_do_begin (ctx, algo);
-	r_hash_calculate (ctx, algo, data, len);
+	r = r_hash_calculate (ctx, algo, data, len);
 	r_hash_do_end (ctx, algo);
 	digest_size = r_hash_size (algo);
 	digest_hex = malloc ((digest_size *2)+1);
